// hardtopEA
// version 1a
// 12-JAN-09
// by jingodelcuyo
#property copyright "free"

#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>

// Hour1 and Hour2 determine the two daily trading times
extern int Hour1=0;
extern int Hour2=9;

// The remaining external variables are self-explanatory
extern double Lot=0.5;
extern int BuyStop=20;
extern int SellStop=20;
extern int TakeProfit=20;
extern int StopLoss=10;
extern int TrailStop=10;
// UseTrailStop=false turns off the TrailStop feature
extern bool UseTrailStop=true;

// Trade accounting variables
bool won;
bool orderOpened[2];
double old[2][2];
double new[2][2];
int otc[6];
int hr[2];

int init() {
   // Just in case the values of Hour1 and Hour2 are reversed...
   if (Hour1<=Hour2) {
      hr[0]=Hour1;
      hr[1]=Hour2;
   } else {
      hr[0]=Hour2;
      hr[1]=Hour1;
   }
   if (Hour1==Hour2) hr[1]=hr[0]+1;
   return(0);
}

int deinit() {
   return(0);
}

int start() {
   orderTracking(); // Basic trade accounting
   events(0); // update trade status; look for trades that have closed TP (won)
   if (otc[0]>0 || otc[1]>0) deletePendingOrders(); // If one of the stop orders is triggered, delete the other one
   if (UseTrailStop) trailStop();
   if (Hour()==hr[0] && won==false && orderOpened[0]==false) openOrders(0); // open the first set of stop orders
   if (Hour()==hr[1] && won==false && orderOpened[1]==false) openOrders(1); // open the second set of stop orders
   if (Hour()>hr[1]) { // reset timing/order criteria
      won=false;
      orderOpened[0]=false;
      orderOpened[1]=false;
   }
   return(0);
}

int openOrders(int id) { // open a buy stop and a sell stop
   double OP, SL, TP;
   OP=Ask+BuyStop*Point;
   TP=OP+TakeProfit*Point;
   SL=OP-StopLoss*Point;
   OrderSend(Symbol(),4,Lot,OP,2,SL,TP,"",0);
   OP=Bid-SellStop*Point;
   TP=OP-TakeProfit*Point;
   SL=OP+StopLoss*Point;
   OrderSend(Symbol(),5,Lot,OP,2,SL,TP,"",0);
   orderOpened[id]=true;
   return(0);
}

int deletePendingOrders() { // delete pending orders
   for (int i=0; i<OrdersTotal(); i++) {
      OrderSelect(i,SELECT_BY_POS);
      if (OrderType()==4 || OrderType()==5) {
         bool del=OrderDelete(OrderTicket());
         if (del==false) {} // error processing
      }
   }
}

int orderTracking() { // update order tracking
   int i=0;
   ArrayCopy(old, new);
   ArrayInitialize(new, 0);
   ArrayInitialize(otc, 0);
   for (int j=0; j<OrdersTotal(); j++) {
      if ((OrderSelect(j, SELECT_BY_POS)==true) && (OrderSymbol()==Symbol())) {
         i++;
         new[i][1]=OrderTicket();
         otc[OrderType()]++;
      }
   }
   new[0][0]=i;
}

int events(int rev) { 
   bool s;
   for(int i=1;i<=old[0][0];i++) {                
      s=false;      
      for(int j=1;j<=new[0][0];j++) {      
         if (old[i][1]==new[j][1]) {
            s=true;     
            break;         
         }    
      }
      // look for closed trades, and if profitable, set won=true
      if (s==false) { 
         OrderSelect(old[i][1],SELECT_BY_TICKET);
         if (OrderProfit()>0) won=true;
      }
   }
   for(j=1; j<=new[0][0]; j++) {
      s=false;      
      for(i=1; i<=old[0][0]; i++) {       
         if (new[j][1]==old[i][1]) {         
            s=true;          
            break;                        
         }                            
      }
   }
   return;
}

int trailStop() { // modify order to update stoploss value
   int d;
   double TS;
   for(int j=1;j<=new[0][0];j++) {
      if (OrderSelect(new[j][1],SELECT_BY_TICKET)) {
         switch (OrderType()) {
            case 0: 
               d=(Ask-OrderStopLoss())/Point;
               if (d>TrailStop) {
                  TS=Ask-TrailStop*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),TS,OrderTakeProfit(),0);
               }
               break;
            case 1: 
               d=(OrderStopLoss()-Bid)/Point;
               if (d>TrailStop) {
                  TS=Bid+TrailStop*Point;
                  OrderModify(OrderTicket(),OrderOpenPrice(),TS,OrderTakeProfit(),0);
               }
               break;
         }
      }
   }
}